// This may look like C code, but it is really -*- C++ -*-
// WARNING: This file is obsolete.  Use ../SLList.h, if you can.
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _MatrixEntryPtrSLList_h
#ifdef __GNUG__
#pragma interface
#endif
#define _MatrixEntryPtrSLList_h 1

#include <Pix.h>
#include "MatrixEntryPtr.defs.h"

#ifndef _MatrixEntryPtrSLListNode_h
#define _MatrixEntryPtrSLListNode_h 1

struct MatrixEntryPtrSLListNode
{
  MatrixEntryPtr                    hd;
  MatrixEntryPtrSLListNode*         tl;
                         MatrixEntryPtrSLListNode() { }
                         MatrixEntryPtrSLListNode(const MatrixEntryPtr  h, MatrixEntryPtrSLListNode* t = 0);
                         ~MatrixEntryPtrSLListNode() { }
};


inline MatrixEntryPtrSLListNode::MatrixEntryPtrSLListNode(const MatrixEntryPtr  h, MatrixEntryPtrSLListNode* t)
:hd(h), tl(t) {}

typedef MatrixEntryPtrSLListNode* MatrixEntryPtrSLListNodePtr;

#endif


class MatrixEntryPtrSLList
{
protected:
  MatrixEntryPtrSLListNode*        last;

public:
                        MatrixEntryPtrSLList();
                        MatrixEntryPtrSLList(const MatrixEntryPtrSLList& a);
                        ~MatrixEntryPtrSLList();

  MatrixEntryPtrSLList&            operator = (const MatrixEntryPtrSLList& a);

  int                   empty();
  int                   length();

  void                  clear();

  Pix                   prepend(MatrixEntryPtr  item);
  Pix                   append(MatrixEntryPtr  item);

  void                  join(MatrixEntryPtrSLList&);

  Pix                   prepend(MatrixEntryPtrSLListNode*);
  Pix                   append(MatrixEntryPtrSLListNode*);

  MatrixEntryPtr&                  operator () (Pix p);
  Pix                   first();
  void                  next(Pix& p);
  int                   owns(Pix p);
  Pix                   ins_after(Pix p, MatrixEntryPtr  item);
  void                  del_after(Pix p);

  MatrixEntryPtr&                  front();
  MatrixEntryPtr&                  rear();
  MatrixEntryPtr                   remove_front();
  int                   remove_front(MatrixEntryPtr& x);
  void                  del_front();

  void                  error(const char* msg);
  int                   OK();
};

inline MatrixEntryPtrSLList::~MatrixEntryPtrSLList()
{
  clear();
}

inline MatrixEntryPtrSLList::MatrixEntryPtrSLList()
{
  last = 0;
}

inline int MatrixEntryPtrSLList::empty()
{
  return last == 0;
}


inline Pix MatrixEntryPtrSLList::first()
{
  return (last == 0)? 0 : Pix(last->tl);
}

inline void MatrixEntryPtrSLList::next(Pix& p)
{
  p = (p == 0 || p == last)? 0 : Pix(((MatrixEntryPtrSLListNode*)(p))->tl);
}

inline MatrixEntryPtr& MatrixEntryPtrSLList::operator () (Pix p)
{
  if (p == 0) error("null Pix");
  return ((MatrixEntryPtrSLListNode*)(p))->hd;
}

inline MatrixEntryPtr& MatrixEntryPtrSLList::front()
{
  if (last == 0) error("front: empty list");
  return last->tl->hd;
}

inline MatrixEntryPtr& MatrixEntryPtrSLList::rear()
{
  if (last == 0) error("rear: empty list");
  return last->hd;
}

#endif
